      integer   maxrefl
      parameter (maxrefl=400000)
      integer   maxfaces
      parameter (maxfaces=100)
      integer   maxparam
      parameter (maxparam=maxfaces)
      integer   maxcorners
      parameter (maxcorners=500)
      integer   maxmodes
      parameter (maxmodes=4)
      integer   maxedges
      parameter (maxedges=maxcorners/2)
      integer   nref
      integer   maxrotaxes
      parameter (maxrotaxes=1000)
      integer   maxmatrices
      parameter (maxmatrices=10000)
      integer   maxcornerMembers
      parameter (maxcornerMembers=32)
      integer   maxFaceMembers
      parameter (maxFaceMembers=32)
      integer   maxDeltaTilt
      parameter (maxDeltaTilt=2)
c---- daughter integer data
      integer   pDh
      integer   pDk
      integer   pDl
      integer   pDbatch
      integer   pDactive
      integer   pDsister
      integer   pDIMAX
      parameter (pDh=1)
      parameter (pDk=2)
      parameter (pDl=3)
      parameter (pDbatch=pDl+1)
      parameter (pDactive=pDbatch+1)
      parameter (pDsister=pDactive+1)
      parameter (pDImax=pDsister)
      integer   dI(pDIMAX,MaxRefl)
c---- daughter real data
      integer   pDintensity
      integer   pDsigma
      integer   pDcosinesF
      integer   pDcosinesL
      integer   pDRMAX
      parameter (pDintensity=1)
      parameter (pDsigma=pDintensity+1)
      parameter (pDcosinesF=pDsigma+1)
      parameter (pDcosinesL=pDcosinesF+5)
      parameter (pDRmax=pDcosinesL)
      real      dR(pDRMAX,MaxRefl)
      common /facelift_daughter/ nref,dI,dR

      integer   HASHBINS
      parameter (HASHBINS=73)
      integer   MAXMOTHER
      parameter (MAXMOTHER=200000/HASHBINS)
      integer   Nunique
      integer   nmother(hashbins)
c---- mother integer data
      integer   pMh
      integer   pMk
      integer   pMl
      integer   pMn
      integer   pMfirst
      integer   pMIMAX
      parameter (pMh=1)
      parameter (pMk=pMh+1)
      parameter (pMl=pMk+1)
      parameter (pMn=pMl+1)
      parameter (pMfirst=pMn+1)
      parameter (pMIMAX=pMfirst)
      integer   mI(pMIMAX,maxmother,hashbins)
c---- mother real data
      integer   pMtheta
      integer   pMangular
      integer   pMsum
      integer   pMmean
      integer   pMmax
      integer   pMmin
      integer   pMRMAX
      parameter (pMtheta=1)
      parameter (pMangular=pMtheta+1)
      parameter (pMsum=pMangular+1)
      parameter (pMmean=pMsum+1)
      parameter (pMmax=pMmean+1)
      parameter (pMmin=pMmax+1)
      parameter (pMRMAX=pMmin)
      real      mR(pMRMAX,maxmother,hashbins)
      common /facelift_mother/ Nunique,nmother,mI,mR

      logical   facesavailable
      integer   nfaces
      integer   nlist
      real      mu
      integer   refineface1     ! pointer in facefactor array
      integer   refineface2     ! optional friedel pointer
      integer   facehkl(3,maxfaces)
      integer   facesave(3,maxfaces)
      real      facedist(maxfaces)
      real      facefactor(maxfaces)
      real      facesurface(maxfaces)
      real      facexyz(3,maxfaces)
      logical   faceactive(maxfaces)
      integer   facelist(maxfaces)
      common /facelift_faces/ facesavailable,nfaces,nlist,mu,
     +     refineface1,refineface2,facehkl,facesave,facedist,
     +     facefactor,facesurface,facexyz,faceactive,facelist

      integer   ncorners
      real      cornerxyz(3,maxcorners)
      logical   FaceCornerTable(maxfaces,maxcorners)
      common /facelift_corners/ ncorners,cornerxyz,FaceCornerTable

      integer   nedges
      integer   edgecorner(2,maxedges)
      integer   edgeface(2,maxedges)
      common /facelift_edges/ nedges,edgecorner,edgeface
      
      integer   nrotaxes
      real      rotaxes(3,maxrotaxes)
      common /facelift_rotax/ nrotaxes,rotaxes

      integer   nmatrices
      real      matrices(3,3,maxmatrices)
      common /facelift_matrix/ nmatrices,matrices

      integer   out
      integer   log
      logical   myrmatavailable
      real      myrmat(3,3)
      real      mydmat(3,3)
      real      mydmatTrans(3,3)
      real      ax(3)
      real      ang(3)
      real      rax(3)
      real      rang(3)
      real      lambda
      real      ang109
      real      cona
      real      coscona
      real      phifact
      integer   naccept
      integer   ngroups
      integer   nhklmin
      real      thetamin
      real      intmin
      real      angdistmax

      integer   npoint
      logical   step
      real      weight1
      real      weight2
      real      initr
      real      bestr
      logical   improved
      logical   CentricShape
      real      badr
      real      zeroDET
      real      zeroXYZ
      real      zeroDIST
      real      zeroANG
      real      improve
      logical   menu
      logical   cellcheck
      real      cellaxes(3)
      real      cellangles(3)
      logical   useablehklfile
      logical   windowexists
      real      xtaldim(3)
      real      xtalrot(3)
      integer   deltatilt
      real      OrientSimplexAngle
      common /facelift_misc/ out,log,myrmatavailable,myrmat,mydmat,
     +     mydmatTrans,ax,ang,rax,rang,ang109,lambda,cona,coscona,
     +     phifact,naccept,ngroups,nhklmin,thetamin,intmin,npoint,step,
     +     angdistmax,weight1,weight2,initr,bestr,improved,
     +     CentricShape,badr,zeroDET,zeroXYZ,zeroDIST,zeroANG,
     +     improve,menu,cellcheck,cellaxes,cellangles,
     +     useablehklfile,windowexists,xtaldim,xtalrot,deltatilt,
     +     OrientSimplexAngle

      character pointgroup*6
      character colourfg*80
      character colourbg*80
      character colourcosi*80
      character colourcoso*80
      character colourcircle*80
      character colouraxesfg*80
      character colouraxesbg*80
      character colourfacesfg*80
      character colourfacesbg*80
      character compound*80
      character projmodes(maxmodes)*20
      character correctlabel*80
      character subrname*80
      character workfile*80
      character correctionmethod*4
      character rmatfile*80
      common /facelift_char/ pointgroup,
     +     colourfg,colourbg,colourcosi,colourcoso,colourcircle,
     +     colouraxesfg,colouraxesbg,colourfacesfg,colourfacesbg,
     +     compound,projmodes,correctlabel,subrname,workfile,
     +     correctionmethod,rmatfile

      logical   graphics
      integer   colfg
      integer   colcosi
      integer   colcoso
      integer   colcircle
      integer   colc
      integer   colaxfg
      integer   colaxbg
      integer   colfacesfg
      integer   colfacesbg
      logical   newwindow
      integer   size
      integer   posx
      integer   posy
      integer   screenx
      integer   screeny
      integer   projectionmode
      integer   pointsize
      logical   vectorsync
      logical   newworld
      real      viewvec(3)
      real      viewrot
      real      viewpartial
      real      viewspeed
      logical   doplotcorner
      logical   doplotaxes
      logical   movie
      integer   WindowShape
      logical   vertical
      logical   doplotlab
      common /facelift_graphics/ graphics,colfg,
     +     colcosi,colcoso,colcircle,colc,colaxfg,colaxbg,colfacesfg,
     +     colfacesbg,newwindow,size,posx,posy,screenx,screeny,
     +     projectionmode,pointsize,vectorsync,newworld,viewvec,
     +     viewrot,viewpartial,viewspeed,doplotcorner,doplotaxes,movie,
     +     WindowShape,vertical,doplotlab

      integer ShapeSmall
      integer ShapeBig
      integer ShapeMakeBig
      parameter (ShapeSmall=0)
      parameter (ShapeBig=2)
      parameter (ShapeMakeBig=1)


      logical DoDeactivate
      logical DoNotDeactivate
      logical ExtraOutput
      logical NoExtraOutput
      logical AddFriedel
      logical NoFriedel
      parameter (DoDeactivate=.true.)
      parameter (DoNotDeactivate=.false.)
      parameter (ExtraOutput=.true.)
      parameter (NoExtraOutput=.false.)
      parameter (AddFriedel=.true.)
      parameter (NoFriedel=.false.)
